﻿//
//// mmgic3az.dll  Header Ver3.1305a
//
//   (C) m.magic & K Maruyama.  All rights reserved.
using System;
using System.Runtime.InteropServices;
using System.Text;

namespace m3az
{
     class maz
    {
        //
        //// 共通
        //

        // 定数
        public const int NULL		= 0;
        public const int MAX_PATH	= 260;
        public const int YES		= 1;
        public const int NO			= 0;
        public const int OK			= 1;
        public const int CANCEL		= 0;

        // 戻り値
        public const int SUCCESS	= 0;
        public const int FAILURE	= -1;
        public const int TRUE		= 1;
        public const int FALSE		= 0;
        // 型
        public struct RECT
        {
            public int left;
            public int top;
            public int right;
            public int bottom;
            public void initialize()
            {
                 left = top = right = bottom = 0;
            }
        }

        //
        ////  ディスク
        //
        //* mazGetDriveType *//
        // 定数
        public const int DRIVE_UNKNOWN      = 0; //The drive type cannot be determined.
        public const int DRIVE_NO_ROOT_DIR  = 1; //The root path is invalid. For example, no volume is mounted at the path.
        public const int DRIVE_REMOVABLE    = 2; //The disk can be removed from the drive.
        public const int DRIVE_FIXED        = 3; //The disk cannot be removed from the drive.
        public const int DRIVE_REMOTE       = 4; //The drive is a remote (network) drive.
        public const int DRIVE_CDROM        = 5; //The drive is a CD-ROM drive.
        public const int DRIVE_RAMDISK      = 6; //The drive is a RAM disk.
        //* mazGetLogicalDrives *//
        public const uint DRIVE_A = 0x0000001;
        public const uint DRIVE_B = 0x0000002;
        public const uint DRIVE_C = 0x0000004;
        public const uint DRIVE_D = 0x0000008;
        public const uint DRIVE_E = 0x0000010;
        public const uint DRIVE_F = 0x0000020;
        public const uint DRIVE_G = 0x0000040;
        public const uint DRIVE_H = 0x0000080;
        public const uint DRIVE_I = 0x0000100;
        public const uint DRIVE_J = 0x0000200;
        public const uint DRIVE_K = 0x0000400;
        public const uint DRIVE_L = 0x0000800;
        public const uint DRIVE_M = 0x0001000;
        public const uint DRIVE_N = 0x0002000;
        public const uint DRIVE_O = 0x0004000;
        public const uint DRIVE_P = 0x0008000;
        public const uint DRIVE_Q = 0x0010000;
        public const uint DRIVE_R = 0x0020000;
        public const uint DRIVE_S = 0x0040000;
        public const uint DRIVE_T = 0x0080000;
        public const uint DRIVE_U = 0x0100000;
        public const uint DRIVE_V = 0x0200000;
        public const uint DRIVE_W = 0x0400000;
        public const uint DRIVE_X = 0x0800000;
        public const uint DRIVE_Y = 0x1000000;
        public const uint DRIVE_Z = 0x2000000;
        //* mazGetVolumeInformation *//
        // 定数
        public const uint GVI_CASE_IS_PRESERVED         = 0x2;      // ファイル名を記録するときに、大文字と小文字を区別して保存します。
        public const uint GVI_CASE_SENSITIVE            = 0x1;      // ファイル名の大文字と小文字の区別をサポートしています。
        public const uint GVI_UNICODE_STORED_ON_DISK    = 0x4;      // Unicode のファイル名をサポートしていて、ディスク上でも正しく表示されます。
        public const uint GVI_PERSISTENT_ACLS           = 0x8;      // ACL（アクセス制御リスト）の保存と適用を行います。
        public const uint GVI_FILE_COMPRESSION          = 0x10;     // ファイルベースの圧縮をサポートしています。
        public const uint GVI_VOL_IS_COMPRESSED         = 0x8000;   // 圧縮ボリュームです。
        public const uint GVI_NAMED_STREAMS             = 0x40000;  // 名前付きストリームをサポートしています。
        public const uint GVI_SUPPORTS_ENCRYPTION       = 0x20000;  // 暗号化ファイルシステム（EFS）をサポートしています。
        public const uint GVI_SUPPORTS_OBJECT_IDS       = 0x10000;  // オブジェクト識別子をサポートしています。
        public const uint GVI_SUPPORTS_REPARSE_POINTS   = 0x80;     // 再解析ポイントをサポートしています。
        public const uint GVI_SUPPORTS_SPARSE_FILES     = 0x40;     // 疎なファイル、未使用の領域が多い、または同じ値が長く続くファイルをサポートしています。
        public const uint GVI_VOLUME_QUOTAS             = 0x20;     // ディスククォータをサポートしています。
        // 型
        public struct GVI_VOLUME_INFORMATION
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 256)]
            public string volumeName;
            public int volumeSerialNumber;
            public int maximumComponentLength;
            public int fileSystemFlags;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 256)]
            public string systemName;
            public void initialize()
            {
                volumeSerialNumber = maximumComponentLength = fileSystemFlags = 0;
                volumeName = new string('\0', 256);
                systemName = new string('\0', 256);
            }
        }

        //
        //// ファイル
        //
        //* mazGetFileVersionEx *//
        // 引数
        public const uint GFV_FILE_VERSION_SIZE = MAX_PATH;
        // 型
        public struct GFV_FILE_VERSION
        {
	        public uint major;
            public uint minor;
            public uint revision;
            public uint bild;
            public uint length;   // filePath のサイズ	
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_PATH)]
            string filePath;      // 獲得したバージョンのファイルパス
            public void initialize()
            {
                 major = minor = revision = bild = length = 0;
                 filePath = new string('\0', MAX_PATH);
            }
        }

        //* mazShowDirListBox *//
        // 引数
        public const uint SDB_TYPE_A = 0x1003;
        public const uint SDB_TYPE_B = 0x1243;
        public const uint SDB_TYPE_C = 0x1043; 
        // 型
       public struct SDB_INFORMATION
       {
	        public IntPtr   wnd;
	        public uint     style;
	        public int		x;
	        public int		y;
	        public int		width;
	        public int		height;
	        public string   msg;
	        public string   currentDirectory;
	        public int	    reserved;
            public void initialize()
            {
                wnd = IntPtr.Zero;
                style = 0;
                x = y = width = height = reserved = 0;
                msg = currentDirectory = "";
	        }
        }
        //* mazGetSpecialFolderPath *//
        // 定数
        public const uint SFP_ADMINTOOLS = 0x30;
        public const uint SFP_APPDATA = 0x1A;
        public const uint SFP_ADMINTOOLS_A = 0x30;
        public const uint SFP_COMMON_APPDATA = 0x23;
        public const uint SFP_COMMON_DESKTOPDIRECTORY = 0x19;
        public const uint SFP_COMMON_DOCUMENTS = 0x2E;
        public const uint SFP_COMMON_FAVORITES = 0x1F;
        public const uint SFP_COMMON_MUSIC = 0x35;
        public const uint SFP_COMMON_PICTURES = 0x36;
        public const uint SFP_COMMON_PROGRAMS = 0x17;
        public const uint SFP_COMMON_STARTMENU = 0x16;
        public const uint SFP_COMMON_STARTUP = 0x18;
        public const uint SFP_COMMON_TEMPLATES = 0x2D;
        public const uint SFP_COOKIES = 0x21;
        public const uint SFP_DESKTOP = 0x0;
        public const uint SFP_DESKTOPDIRECTORY = 0x10;
        public const uint SFP_FAVORITES = 0x6;
        public const uint SFP_FONTS = 0x14;
        public const uint SFP_HISTORY = 0x22;
        public const uint SFP_INTERNET_CACHE = 0x20;
        public const uint SFP_LOCAL_APPDATA = 0x1C;
        public const uint SFP_MYMUSIC = 0xD;
        public const uint SFP_MYPICTURES = 0x27;
        public const uint SFP_MYVIDEO = 0xE;
        public const uint SFP_PERSONAL = 0x5;
        public const uint SFP_PROGRAM_FILES = 0x26;
        public const uint SFP_PROGRAM_FILES_COMMON = 0x2B;
        public const uint SFP_PROGRAMS = 0x2;
        public const uint SFP_RECENT = 0x8;
        public const uint SFP_STARTMENU = 0xB;
        public const uint SFP_STARTUP = 0x7;
        public const uint SFP_SYSTEM_A = 0x25;
        public const uint SFP_TEMPLATES = 0x15;
        public const uint SFP_WINDOWS = 0x24;
        //* mazGetFileAttributes & mazGetFileAttributes *//
        // 定数
        public const uint ATR_ARCHIVE       = 0x20;         //アーカイブファイルまたはアーカイブディレクトリです。
        public const uint ATR_COMPRESSED    = 0x800;        // ファイルまたはディレクトリは圧縮されています。
        public const uint ATR_DEVICE        = 0x40;         //予約済み。使わないでください。
        public const uint ATR_DIRECTORY     = 0x20;         //ディレクトリ。
        public const uint ATR_ENCRYPTED     = 0x4000;       //ファイルまたはディレクトリは暗号化されています。
        public const uint ATR_HIDDEN        = 0x2;          //隠しファイルまたは隠しディレクトリです。
        public const uint ATR_NORMAL        = 0x80;         //ファイルまたはディレクトリには、特に属性はありません。
        public const uint ATR_NOT_CONTENT_INDEXED = 0x2000; // Windows 2000：インデックスサービスの対象になっていません。
        public const uint ATR_OFFLINE       = 0x1000;       // Windows 2000：このファイルのデータは、すぐには利用できません。
        public const uint ATR_READONLY      = 0x1;          // ファイルまたはディレクトリは読み取り専用です。
        public const uint ATR_REPARSE_POINT = 0x400;        //再解析ポイントが関連付けられています。
        public const uint ATR_SPARSE_FILE   = 0x200;        //疎なファイル、未使用の領域が多い、または同じ値が長く続くファイルです。
        public const uint ATR_SYSTEM        = 0x4;          //ファイルまたはディレクトリは、オペレーティングシステム専用です。
        public const uint ATR_TEMPORARY     = 0x100;
        //* mazGetWindowsPath *//
        // 引数
        public const int GWP_WINDOWS_PATH   = 1;
        public const int GWP_SYSTEM_PATH    = 2;
        //* mazGetFileTime & mazSetFileTime *//
        // 引数
        public const int FTM_TIME_KIND      = 0x00ff;
        public const int FTM_CREATE_TIME    = 0x0001;
        public const int FTM_ACCESS_TIME    = 0x0002;
        public const int FTM_WRITE_TIME     = 0x0004;
        // 型
        public struct SYSTEMTIME
        {
            public short year;
            public short month;
            public short dayOfWeek;
            public short day;
            public short hour;
            public short minute;
            public short second;
            public short milliseconds;
            public void  initialize()
            {
                year = month = dayOfWeek = day = hour = minute = second = milliseconds = 0;
            }
        }
        //* mazSearchDirectory *//
        // 引数
        public const int SDR_SEARCH_OPTIONS		= 0x00ff;
        public const int SDR_SEARCH				= 0x0000;
        public const int SDR_NO_SUBDIR			= 0x0000;
        public const int SDR_INCLUDE_SUBDIR		= 0x0001;
        public const int SDR_NO_DIR_NAME        = 0x0000;
        public const int SDR_INCLUDE_DIR_NAME	= 0x0002;
        public const int SDR_ATTRIBUTES_TYPE	= 0xff00;
        public const int SDR_NORMAL_ATTRIBUTES	= 0x0000;
        public const int SDR_INCLUDE_ARCHIVE	= 0x0100;
        public const int SDR_INCLUDE_HIDDEN		= 0x0200;
        public const int SDR_INCLUDE_READONLY	= 0x0400;
        public const int SDR_INCLUDE_SYSTEM		= 0x0800;
        // 戻り値
        public const int SDR_ERR_OPENING_FILE	= -200;
        public const int SDR_ERR_CANCEL			= -201;
        // コールバック関数
        public const int SDR_BEGINE_PROCESS     = 0;
        public const int SDR_END_PROCESS        = -1000000;
        // 型
        public delegate int DIRSEARCHAZ( int number, 
                                         string fileName,
                                         uint attributes,
                                         DirectorySearch.SDR_FREE_PARAMETERS freeParams);

        public struct SDR_DIRECTORY_SEARCH
        {
	        public DIRSEARCHAZ		                    process;	// コールバック関数のポインタ	
            public DirectorySearch.SDR_FREE_PARAMETERS  freeParams;	// 汎用ポインタ
        }                                                           // このポインタは、コールバック関数にそのまま渡される
        

        //
        //// レジストリ
        //
        //* mazGetRegData & mazSetRegData *//
        // 引数
        // function
        public const int REG_READ			= 2;
        public const int REG_READ_SIZE		= 3;
        // key
        public const int REG_ROOT			        = 1;
        public const int REG_CURRENT_CONFIG	        = 2;
        public const int REG_CURRENT_USER	        = 3;
        public const int REG_LOCAL_MACHINE	        = 4;
        public const int REG_USER			        = 5;
        public const int REG_DYN_DATA               = 6;
        public const int REG_PERFORMANCE_DATA	    = 7;
        public const int REG_PERFORMANCE_NLSTEXT    = 8;
        public const int REG_PERFORMANCE_TEXT       = 9;
        // type
        public const uint REG_SZ		= 1;
        public const uint REG_BINARY	= 3;
        public const uint REG_DWORD     = 4;
        public const uint REG_QWORD     = 11;


        //
        //// システム情報
        //
        //* mazGetWinVersion *//
        public const int GWV_PLATFORM_WIN32s        = 0;    // Win32s on Windows 3.1. 
        public const int GWV_PLATFORM_WIN32_WINDOWS = 1;    // Windows 95, Windows 98, or Windows Me. 
        public const int GWV_PLATFORM_WIN32_NT      = 1;
        // 型
        public struct GWV_OSVERSIONINFO
        {
            public int osVersionInfoSize;
            public int majorVersion;
            public int minorVersion;
            public int buildNumber;
            public int platformId;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 128)]
            public string csdVersion;
            public void initialize()
            {
                osVersionInfoSize = majorVersion = minorVersion = buildNumber = platformId = 0;
                csdVersion = new string('\0', 128);
            }
        }
        //* mazGetMemoryStatus *//
        // 型
        public struct MEMORYSTATUSEX
        {
            public uint  length;
            public uint  memoryLoad;
            public ulong totalPhys;
            public ulong availPhys;
            public ulong totalPageFile;
            public ulong availPageFile;
            public ulong totalVirtual;
            public ulong availVirtual;
            public ulong availExtendedVirtual;
            public void  initialize()
            {
                length = memoryLoad = 0;
                totalPhys = availPhys = totalPageFile = availPageFile = 0;
                totalVirtual = availVirtual = availExtendedVirtual = 0;
            }
        }
        //* mazGetCpuInformations *//
        // 引数
        public const int GCI_DO_NOT_WRITE_TO_FILE	= NULL;
        public const int GCI_MAX_VNAME_LEN		    = 14;
        public const int GCI_MAX_MNAME_LEN		    = 50;
        public const int GCI_MAX_STANDERD_COUNT	    = 64;
        public const int GCI_MAX_EXTENDED_COUNT	    = 64;
        // register
        public const int GCI_EAX    = 0;
        public const int GCI_EBX	= 1;
        public const int GCI_ECX	= 2;
        public const int GCI_EDX	= 3;
        // 3d commands
        public const uint GCI_FEATURE_MMX		= 0x000100;
        public const uint GCI_FEATURE_MMX_EXT	= 0x000200;
        public const uint GCI_FEATURE_SSE		= 0x000400;
        public const uint GCI_FEATURE_SSE2		= 0x000800;
        public const uint GCI_FEATURE_SSE3		= 0x001000;
        public const uint GCI_FEATURE_SSE4_1	= 0x002000;
        public const uint GCI_FEATURE_SSE4_2	= 0x004000;
        public const uint GCI_FEATURE_3DNOW		= 0x000001;
        public const uint GCI_FEATURE_3DNOW_EXT	= 0x000002;
        public const uint GCI_FEATURE_SSE4_A	= 0x000004;
        // Virtual Machine
        public const int GCI_FEATURE_AMD_V		= 0x010000; 
        public const int GCI_FEATURE_INTEL_VT	= 0x020000;
        // 64-bit technology available 
        public const int GCI_FEATURE_X64		= 0x040000; 
        // 戻り値
        public const int GCI_ERR_NOT_SUPPORTED	= 10000;
        public const int GCI_ERR_FILE			= -10000;
        public const int GCI_ERR_OUTPUT_BUFFER	= -10001;
        // 型
        public struct GCI_CPUID
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 4)]
	        int[] value;
            public void initialize() 
            {
                value = new int[4];
            }
        }
        public struct GCI_INFORMATION_A
        {
            public int size;	// size of this structure
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = GCI_MAX_STANDERD_COUNT)]
            GCI_CPUID[] cidStandard;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = GCI_MAX_EXTENDED_COUNT)]
            GCI_CPUID[] cidExtended;
            public void initialize()
            {
                size = 2052;
                int i;
                cidStandard = new GCI_CPUID[GCI_MAX_STANDERD_COUNT];
                for (i = 0; i < GCI_MAX_STANDERD_COUNT; i++)
                {
                    cidStandard[i].initialize();
                }
                cidExtended = new GCI_CPUID[GCI_MAX_EXTENDED_COUNT];
                for (i = 0; i < GCI_MAX_EXTENDED_COUNT; i++)
                {
                    cidExtended[i].initialize();
                }
            }
        }
        public struct GCI_INFORMATION_B
        {
            public int   size;			// size of this structure
            public float frequency;		// frequency(MHz)
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = GCI_MAX_VNAME_LEN)]
            public string vendorName;	// vendor name
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = GCI_MAX_MNAME_LEN)]
            public string modelName;	// name of model
            public int  family;			// family of the processor
            public int  extendedFamily;	// extended family of the processor
            public int  baseFamily;		// base family of the processor
            public int  model;			// model of the processor
            public int  extendedModel;	// extended model of the processor
            public int  baseModel;		// base model of the processor
            public int  stepping;		// the processor revision number
            public int  cores;			// the processor count 
            public int  logicalCores;	// the logical processor count 
            public int  threads;		// Thread count
            public uint feature;		// the processor feature
            public void initialize()
            {
                size = 116;
                frequency = 0.0F;
                vendorName = new string((char)0, GCI_MAX_VNAME_LEN);
                modelName = new string((char)0, GCI_MAX_MNAME_LEN);
                family = extendedFamily = baseFamily = model = extendedModel = 0;
                baseModel = stepping = cores = logicalCores = threads = 0;
                feature = 0;
            }
        }


        //
        //// 圧縮/伸張
        //
        //* mazCompress & mazExpand *//
        // 引数
        public const uint CMP_MODE		    = 0x000f;
        public const uint CMP_OPTION		= 0x0ff0;
        public const uint CMP_MODE_4096	    = 0x0002;
        public const uint CMP_MODE_8192     = 0x0003;
        public const uint CMP_MODE_16384    = 0x0004;
        public const uint CMP_MODE_32768    = 0x0005;
        public const uint CMP_MODE_65536    = 0x0006;
        public const uint CMP_OPTION_DIFF   = 0x0010;
        // 型
        public struct CMP_PACK_LZ
        {
            public uint rules;	    // 圧縮方法
            public uint size;       // 元データサイズ
            public uint cmpSize;	// 圧縮データサイズ
            public IntPtr cmpData;  // 圧縮データ
            public void initialize()
            {
                rules = CMP_MODE_4096;
                size = cmpSize = 0;
                cmpData = IntPtr.Zero;
            }
        }
        //* mazDecordByHuffman & mazEncodeByHuffman *//
        // 型
        public struct CMP_PACK_HUFF
        {
            public uint size;		// 元データサイズ
            public uint cmpSize;	// 圧縮データサイズ
            public uint freqSize;	// 出現頻度表サイズ
            public IntPtr freq;	    // 出現頻度表
            public IntPtr cmpData;	// 圧縮データ
            public void initialize()
            {
                size = cmpSize = freqSize = 0;
                freq = IntPtr.Zero;
                cmpData = IntPtr.Zero;
            }
        } 

         
        //
        //// 文字/数値 変換
        //
        public const int CDS_E = 0;
        public const int CDS_F = 1;
        public const int CDS_G = 2;
        public const int CDS_A = 3;


        //
        //// メモリー
        //
        //* mazBitArray *//
        public const int BAR_GET_MEMORY         = 1;
        public const int BAR_SET_BIT	        = 2;
        public const int BAR_RESET_BIT	        = 3;
        public const int BAR_GET_BIT	        = 4;
        public const int BAR_DELETE_PAGE	    = 5;
        public const int BAR_DELETE_ALL_PAGE    = 6;
        //* mazQueue *//
        // 引数
        public const int QUE_TYPE		             = 0x00ff;
        public const int QUE_COMMAND				 = 0xff00;
        public const int QUE_COMMAND_NUMBER          = 0xe000;
        public const int QUE_COMMAND_ONE             = 0x0000;

        public const int QUE_TYPE_INT32				 = 0x0000;
        public const int QUE_TYPE_INT16				 = 0x0001;
        public const int QUE_TYPE_INT64				 = 0x0002;
        public const int QUE_TYPE_BYTE				 = 0x0003;
        public const int QUE_TYPE_FLOAT				 = 0x0004;
        public const int QUE_TYPE_DOUBLE			 = 0x0005;
        public const int QUE_TYPE_CONTAINER_A		 = 0x0006;
        public const int QUE_TYPE_CONTAINER_B		 = 0x0007; // new type
        public const int QUE_CMD_CREATE				 = 0x0000;
        public const int QUE_CMD_DESTROY			 = 0x0100;
        public const int QUE_CMD_POP				 = 0x0200;
        public const int QUE_CMD_PUSH				 = 0x0300;
        public const int QUE_CMD_PEEK				 = 0x0400;
        public const int QUE_CMD_DELCONTAINER		 = 0x0500;
        public const int QUE_CMD_GETCOUNT			 = 0x0600;
        public const int QUE_CMD_CONTAINES			 = 0x0700;
        public const int QUE_CMD_ENUMERATE_BEGINNING = 0x0800;
        public const int QUE_CMD_ENUMERATE			 = 0x0900;
        // 戻り値
        public const int QUE_ERR_MEMORY		= -100;
        public const int QUE_EMPTY			= -3;
        public const int QUE_FULL			= -2;
        public const int QUE_FAILURE		= -1;
        public const int QUE_CONTAINED		= 1;
        public const int QUE_NOT_CONTAINED	= 2;
        // 型
        public struct QUE_CREATE
        {	// キュー / スタック 構築
	        public int valueType;		// データ型
	        public int depth;			// 最大深さ
            public void initialize()
            {
                valueType = 0;
                depth = 0;
            }
        } 
        public struct STK1_CREATE
        {	// キュー / スタック 構築
	        public int valueType;		// データ型
	        public int depth;			// 最大深さ
            public void initialize()
            {
                valueType = 0;
                depth = 0;
            }
        } 
        public struct STK2_CREATE
        {	// キュー / スタック 構築
	        public int valueType;		// データ型
	        public int depth;			// 最大深さ
            public void initialize()
            {
                valueType = 0;
                depth = 0;
            }
        } 

        public struct QUE_QUEUE
        {	// キューオブジェクト
	        public int		depth;		// 最大深さ
	        public int		valueType;	// データ型
	        public IntPtr	queue;		// キューのポインタ
            public void initialize()
            {
                depth = valueType = 0;
                queue = IntPtr.Zero;
            }
        }
        public struct QUE_CONTAINER_A
        {	// データコンテナ
            public int size;			// parameters のサイズ
            public int globalPointer;	// parameters はグローバルか
            public IntPtr parameters;	
            public void initialize()
            {
                size = 0;
                globalPointer = 0;
                parameters = IntPtr.Zero;
            }
        }
        public struct QUE_CONTAINER_A_STRING
        {	// データコンテナ
            public int size;			// parameters のサイズ
            public int globalPointer;	// parameters はグローバルか
            public string parameters;	
            public void initialize()
            {
                size = 0;
                globalPointer = 0;
                parameters = new string('\0', 512);
            }
        }
        
        public struct STK1_CONTAINER_A
        {	// データコンテナ
	        public int	    size;			// parameters のサイズ
	        public int      globalPointer;	// parameters はグローバルか
            public IntPtr   parameters;		
            public void initialize()
            {
                size = 0;
                globalPointer = 0;
                parameters = IntPtr.Zero;
            }
        }
        public struct STK1_CONTAINER_A_STRING
        {	// データコンテナ
            public int size;			// parameters のサイズ
            public int globalPointer;	// parameters はグローバルか
            public string parameters;	
            public void initialize()
            {
                size = 0;
                globalPointer = 0;
                parameters = new string('\0', 512);
            }
        }

        public struct QUE_CONTAINER_B_STRING
        {	// データコンテナ
	        public int		size;		// parameters のサイズ
	        public string   parameters;
            public void initialize()
            {
                size = 0;
                parameters = new string('\0', 512);
            }
        } 
        public struct STK1_CONTAINER_B_STRING
        {	// データコンテナ
            public int size;		// parameters のサイズ
            public string parameters;
            public void initialize()
            {
                size = 0;
                parameters = new string('\0', 512);
            }
        }
        public struct STK2_CONTAINER
        {	// データコンテナ
            public int size;		// parameters のサイズ
            public IntPtr parameters;
            public void initialize()
            {
                size = 0;
                parameters = IntPtr.Zero;
            }
        } 
        public struct STK2_CONTAINER_STRING
        {	// データコンテナ
            public int size;		// parameters のサイズ
            public string parameters;
			public void initialize()
			{
				size = 0;
				parameters = new string('\0', 512);
			}
        } 
        //* mazStack *//
        // 引数
        public const int  STK1_TYPE		        = QUE_TYPE;
        public const int  STK1_COMMAND	        = QUE_COMMAND;
        public const int  STK1_COMMAND_NUMBER   = QUE_COMMAND_NUMBER;
        public const int  STK1_COMMAND_ONE 	    = 0x0000;

        public const int  STK1_TYPE_INT32			= QUE_TYPE_INT32;
        public const int  STK1_TYPE_INT16			= QUE_TYPE_INT16;
        public const int  STK1_TYPE_INT64			= QUE_TYPE_INT64;
        public const int  STK1_TYPE_BYTE			= QUE_TYPE_BYTE;
        public const int  STK1_TYPE_FLOAT			= QUE_TYPE_FLOAT;
        public const int  STK1_TYPE_DOUBLE			= QUE_TYPE_DOUBLE;
        public const int  STK1_TYPE_CONTAINER_A	    = QUE_TYPE_CONTAINER_A;
        public const int  STK1_TYPE_CONTAINER_B	    = QUE_TYPE_CONTAINER_B;
        public const int  STK1_CMD_CREATE			= QUE_CMD_CREATE;
        public const int  STK1_CMD_DESTROY			= QUE_CMD_DESTROY;
        public const int  STK1_CMD_POP				= QUE_CMD_POP;
        public const int  STK1_CMD_PUSH			    = QUE_CMD_PUSH;
        public const int  STK1_CMD_PEEK			    = QUE_CMD_PEEK;
        public const int  STK1_CMD_DELCONTAINER	    = QUE_CMD_DELCONTAINER;

        public const int  STK2_TYPE	            = QUE_TYPE;
        public const int  STK2_COMMAND	        = QUE_COMMAND;
        public const int  STK2_COMMAND_NUBER    = QUE_COMMAND_NUMBER;
        public const int  STK2_COMMAND_TWO  	= 0x2000;

        public const int  STK2_TYPE_INT32			    = QUE_TYPE_INT32;
        public const int  STK2_TYPE_INT16			    = QUE_TYPE_INT16;
        public const int  STK2_TYPE_INT64			    = QUE_TYPE_INT64;
        public const int  STK2_TYPE_BYTE			    = QUE_TYPE_BYTE;
        public const int  STK2_TYPE_FLOAT			    = QUE_TYPE_FLOAT;
        public const int  STK2_TYPE_DOUBLE			    = QUE_TYPE_DOUBLE;
        public const int  STK2_TYPE_CONTAINER		    = QUE_TYPE_CONTAINER_B;
        public const int  STK2_CMD_CREATE			    = 0x2000;
        public const int  STK2_CMD_DESTROY			    = 0x2100;
        public const int  STK2_CMD_POP				    = 0x2200;
        public const int  STK2_CMD_PUSH	    		    = 0x2300;
        public const int  STK2_CMD_PEEK		    	    = 0x2400;
        public const int  STK2_CMD_BACK			        = 0x2500;
        public const int  STK2_CMD_ENUMERATE_BEGINNING  = 0x2600;
        public const int  STK2_CMD_ENUMERATE			= 0x2700;
        // 戻り値
        public const int STK1_ERR_MEMORY	= QUE_ERR_MEMORY;
        public const int STK1_FAILURE		= QUE_FAILURE;
        public const int STK2_ERR_MEMORY	= QUE_ERR_MEMORY;
        public const int STK2_FAILURE		= QUE_FAILURE;

        public struct STK1_STACK
        {	// スタックオブジェクト
	        public int	    depth;		// 最大深さ
            public int      valueType;	// データ型
	        public IntPtr	stack;		// スタックのポインタ
            public void initialize()
            {
                depth = valueType = 0;
                stack = IntPtr.Zero;
            }
        } 
        public struct STK2_STACK
        {	// スタックオブジェクト
            public int      depth;		// 最大深さ
            public int      valueType;	// データ型
	        public IntPtr	stack;		// スタックのポインタ
            public void initialize()
            {
                depth = valueType = 0;
                stack = IntPtr.Zero;
            }
        } 

        //
        //// その他
        //
        //* mazGetTime *//
        // 引数
        public const int GTM_SYSTEM_TIME = 0x0;
        public const int GTM_LOCAL_TIME = 0x1;



        // ディスク
        [DllImport("mmgic3az.dll")]
        public static extern int mazCheckActiveDrive(string driveLetter);
        [DllImport("mmgic3az.dll")]
        public static extern int mazGetDiskSize(string directoryName, ref ulong freeSize, ref ulong totalSize);
        [DllImport("mmgic3az.dll")]
        public static extern int mazGetVolumeInformation(   string rootPathName, 
                                                        ref GVI_VOLUME_INFORMATION volumeInformation);
        [DllImport("mmgic3az.dll")]
        public static extern int mazGetDriveType(string driveLetter);
        [DllImport("mmgic3az.dll")]
        public static extern uint mazGetLogicalDrives();

        // ファイル
        [DllImport("mmgic3az.dll")]
        public static extern int mazGetFileAttributes(string fileName, ref uint attributes);
        [DllImport("mmgic3az.dll")]
        public static extern int mazGetFileTime(uint functions, 
                                                string fileName,
                                                IntPtr createTime,
                                                IntPtr accessTime,
                                            ref SYSTEMTIME writeTime    );
        [DllImport("mmgic3az.dll")]
        public static extern int mazGetFileTime(uint functions, 
                                                string fileName,
                                                IntPtr createTime,
                                            ref SYSTEMTIME accessTime,
                                                IntPtr writeTime    );
        [DllImport("mmgic3az.dll")]
        public static extern int mazGetFileTime(uint functions, 
                                                string fileName,
                                            ref SYSTEMTIME createTime,
                                                IntPtr accessTime, 
                                                IntPtr writeTime    );
        [DllImport("mmgic3az.dll")]
        public static extern int mazGetFileTime(uint functions,
                                                string fileName,
                                            ref SYSTEMTIME createTime,
                                                IntPtr accessTime,
                                            ref SYSTEMTIME writeTime);
        [DllImport("mmgic3az.dll")]
        public static extern int mazGetFileTime(uint functions, 
                                                string fileName,
                                            ref SYSTEMTIME createTime, 
                                            ref SYSTEMTIME accessTime,
                                            ref SYSTEMTIME writeTime);
        
         [DllImport("mmgic3az.dll")]
        public static extern int mazGetFileVersion( string file, 
                                                ref uint major,
                                                ref uint minor,
                                                ref uint revision,
                                                ref uint bild );
        [DllImport("mmgic3az.dll")]
        public static extern int mazGetFileVersionEx(   string fileName,
                                                        uint size, 
                                                    ref GFV_FILE_VERSION version );
        [DllImport("mmgic3az.dll")]
        public static extern int mazGetSpecialFolderPath(StringBuilder pathName, uint folder);
        [DllImport("mmgic3az.dll")]
        public static extern int mazGetWindowsPath(uint function, StringBuilder path);
        [DllImport("mmgic3az.dll")]
        public static extern int mazSearchDirectory(uint function,
                                                    string directory,
                                                    string extension, 
                                                    IntPtr listFile,
                                                ref SDR_DIRECTORY_SEARCH directorySearch  );
        [DllImport("mmgic3az.dll")]
        public static extern int mazSearchDirectory(uint function,
                                                    string directory,
                                                    string extension,
                                                    IntPtr listFile,
                                                    IntPtr directorySearch  );
        [DllImport("mmgic3az.dll")]
        public static extern int mazSearchDirectory(uint function,
                                                    string directory,
                                                    string extension,
                                                    string listFile,
                                                ref SDR_DIRECTORY_SEARCH directorySearch  );
        [DllImport("mmgic3az.dll")]
        public static extern int mazSearchDirectory(uint function, 
                                                    string directory,
                                                    string extension,
                                                    string listFile,
                                                    IntPtr directorySearch  );
        [DllImport("mmgic3az.dll")]
        public static extern int mazSetFileAttributes(string fileName, uint attributes);
        [DllImport("mmgic3az.dll")]
        public static extern int mazSetFileTime(uint functions, 
                                                string fileName,
                                                IntPtr createTime,
                                                IntPtr accessTime,
                                            ref SYSTEMTIME writeTime);
        [DllImport("mmgic3az.dll")]
        public static extern int mazSetFileTime(uint functions,
                                                string fileName,
                                                IntPtr createTime, 
                                            ref SYSTEMTIME accessTime,
                                                IntPtr writeTime);
        [DllImport("mmgic3az.dll")]
        public static extern int mazSetFileTime(uint functions, 
                                                string fileName,
                                            ref SYSTEMTIME createTime,
                                                IntPtr accessTime,
                                                IntPtr writeTime);
        [DllImport("mmgic3az.dll")]
        public static extern int mazSetFileTime(uint functions, 
                                                string fileName,
                                            ref SYSTEMTIME createTime, 
                                            ref SYSTEMTIME accessTime,
                                            ref SYSTEMTIME writeTime);
        [DllImport("mmgic3az.dll")]
        public static extern int mazShowDirListBox(ref SDB_INFORMATION info, StringBuilder directoryName);
        [DllImport("mmgic3az.dll")]
        public static extern uint mazGetLongFileName(string shortName, IntPtr longName);
        [DllImport("mmgic3az.dll")]
        public static extern uint mazGetLongFileName(string shortName, StringBuilder longName);
        [DllImport("mmgic3az.dll")]
        public static extern uint mazGetShortFileName(string longName, IntPtr shortName);
        [DllImport("mmgic3az.dll")]
        public static extern uint mazGetShortFileName(string longName, StringBuilder shortName);
        [DllImport("mmgic3az.dll")]
        public static extern int mazGetTempFileName(StringBuilder fileName);
        [DllImport("mmgic3az.dll")]
        public static extern ulong mazGetFileSize(string fileName);

        // レジストリ
        [DllImport("mmgic3az.dll")]
        public static extern int mazGetRegData(	uint function,
                                                int key, 
                                                string subKey,
                                                string name,
                                                uint type,
												byte[] data, 
											ref uint size );
        [DllImport("mmgic3az.dll")]
        public static extern int mazGetRegData( uint function, 
												int key,
                                                string subKey,
                                                string name,
                                                uint type,
                                                IntPtr data,
											ref uint size );
        [DllImport("mmgic3az.dll")]
        public static extern int mazSetRegData( int key, 
                                                string subKey,
                                                string name,
                                                uint type,
                                                byte[] data,
                                                uint size );

        // システム情報
        [DllImport("mmgic3az.dll")]
        public static extern int mazGetComputerName(StringBuilder computerName);
        [DllImport("mmgic3az.dll")]
        public static extern int mazGetCpuInformationsA(ref GCI_INFORMATION_A informationsA,
                                                            int fileName);
        [DllImport("mmgic3az.dll")]
        public static extern int mazGetCpuInformationsA(ref GCI_INFORMATION_A informationsA,
                                                            string fileName);
        [DllImport("mmgic3az.dll")]
        public static extern int mazGetCpuInformationsB(    uint time, 
                                                        ref GCI_INFORMATION_B informationsB);
        [DllImport("mmgic3az.dll")]
        public static extern int mazGetLoginName(StringBuilder loginName);
        [DllImport("mmgic3az.dll")]
        public static extern int mazGetMemoryStatusEx(ref MEMORYSTATUSEX buffer);
        [DllImport("mmgic3az.dll")]
        public static extern void mazGetWinVersion(ref GWV_OSVERSIONINFO versionInfo);

        // 圧縮/伸張
        [DllImport("mmgic3az.dll")]
        public static extern int mazCompress(byte[] data, ref CMP_PACK_LZ cmpPack);
        [DllImport("mmgic3az.dll")]
        public static extern int mazDecodeByHuffman(ref CMP_PACK_HUFF cmpPack,
                                                        byte[] destination);
        [DllImport("mmgic3az.dll")]
        public static extern int mazEncodeByHuffman(    byte[] source,
                                                    ref CMP_PACK_HUFF cmpPack);
        [DllImport("mmgic3az.dll")]
        public static extern int mazExpand(ref CMP_PACK_LZ cmpPack, byte[] data);
        [DllImport("mmgic3az.dll")]
        public static extern uint mazDecodeByWeyl(byte[] source, uint[] original, uint originalSize);
        [DllImport("mmgic3az.dll")]
        public static extern uint mazEncodeByWeyl(  uint[] source, 
                                                    byte[] destination,
                                                    uint sourceSize,
                                                    uint destinatiosize );
        [DllImport("mmgic3az.dll")]
        public static extern void mazDeleteCmpPack(ref CMP_PACK_LZ cmpPack);
        [DllImport("mmgic3az.dll")]
        public static extern void mazDeleteCmpPackHuffman(ref CMP_PACK_HUFF cmpPack);

        // 演算関数
        [DllImport("mmgic3az.dll")]
        public static extern int mazCompareInt64(ref long a, ref long b);
        [DllImport("mmgic3az.dll")]
        public static extern long mazAddInt64(ref long a, ref long b);
        [DllImport("mmgic3az.dll")]
        public static extern long mazDivideInt64(ref long a, ref long b);
        [DllImport("mmgic3az.dll")]
        public static extern long mazMultiplyInt64(ref long a, ref long b);
        [DllImport("mmgic3az.dll")]
        public static extern long mazSetInt64(string number);
        [DllImport("mmgic3az.dll")]
        public static extern long mazSubtractInt64(ref long a, ref long b);

        // CRC
        [DllImport("mmgic3az.dll")]
        public static extern uint mazGetCRC32(int reset, uint n, byte[] a);
        [DllImport("mmgic3az.dll")]
        public static extern uint mazGetCRC32(int reset, uint n, IntPtr a);
        [DllImport("mmgic3az.dll")]
        public static extern uint mazGetCRC32ofFile(string fileName);
        [DllImport("mmgic3az.dll")]
        public static extern ushort mazGetCRC16(int reset, ushort n, byte[] a);
        [DllImport("mmgic3az.dll")]
        public static extern ushort mazGetCRC16(int reset, ushort n, IntPtr a);
        [DllImport("mmgic3az.dll")]
        public static extern ushort mazGetCRC16ofFile(string fileName);

        // 文字/数値 変換
        [DllImport("mmgic3az.dll")]
        public static extern int mazCDoubleToInt32(double d);
        [DllImport("mmgic3az.dll")]
        public static extern long mazCDoubleToInt64(double d);
        [DllImport("mmgic3az.dll")]
        public static extern short mazCDoubleToInt16(double d);
        [DllImport("mmgic3az.dll")]
        public static extern void mazCDoubleToString(double d, int type, StringBuilder sb);
        [DllImport("mmgic3az.dll")]
        public static extern int mazCSingleToInt32(float s);
        [DllImport("mmgic3az.dll")]
        public static extern long mazCSingleToInt64(float s);
        [DllImport("mmgic3az.dll")]
        public static extern short mazCSingleToInt16(float s);
        [DllImport("mmgic3az.dll")]
        public static extern uint mazCByteToInt32(byte[] b);
        [DllImport("mmgic3az.dll")]
        public static extern uint mazCByteToString(byte[] b, IntPtr ip, uint size);
        [DllImport("mmgic3az.dll")]
        public static extern uint mazCByteToString(byte[] b, StringBuilder sb, uint size);
        [DllImport("mmgic3az.dll")]
        public static extern uint mazCStringToByte(string s, byte[] b, uint size);
        [DllImport("mmgic3az.dll")]
        public static extern uint mazCStringToByte(string s, IntPtr ip, uint size);
        [DllImport("mmgic3az.dll")]
        public static extern ulong mazCByteToInt64(byte[] b);
        [DllImport("mmgic3az.dll")]
        public static extern ushort mazCByteToInt16(byte[] b);
        [DllImport("mmgic3az.dll")]
        public static extern void mazCInt16ToByte(ushort s, byte[] b);
        [DllImport("mmgic3az.dll")]
        public static extern void mazCInt16ToString(ushort us, int radix, StringBuilder sb);
        [DllImport("mmgic3az.dll")]
        public static extern void mazCInt32ToByte(uint ui, byte[] b);
        [DllImport("mmgic3az.dll")]
        public static extern void mazCInt32ToString(uint ui, int radix, StringBuilder sb);
        [DllImport("mmgic3az.dll")]
        public static extern void mazCInt64ToByte(ref ulong ul, byte[] b);
        [DllImport("mmgic3az.dll")]
        public static extern void mazCInt64ToString(ref long l, int radix, StringBuilder sb);
        [DllImport("mmgic3az.dll")]
        public static extern void mazCSingleToString(float f, int type, StringBuilder sb);
        [DllImport("mmgic3az.dll")]
        public static extern void mazStringLower(StringBuilder sb);
        [DllImport("mmgic3az.dll")]
        public static extern void mazStringUpper(StringBuilder sb);  

        // 数値データ
        [DllImport("mmgic3az.dll")]
        public static extern byte mazShiftByteL(byte s, int shift);
        [DllImport("mmgic3az.dll")]
        public static extern byte mazShiftByteR(byte s, int shift);
        [DllImport("mmgic3az.dll")]
        public static extern double mazRand0d();
        [DllImport("mmgic3az.dll")]
        public static extern uint mazRand0i();
        [DllImport("mmgic3az.dll")]
        public static extern uint mazShiftInt32L(uint a, int shift);
        [DllImport("mmgic3az.dll")]
        public static extern uint mazShiftInt32R(uint a, int shift);
        [DllImport("mmgic3az.dll")]
        public static extern ulong mazShiftInt64L(ref ulong a, int shift);
        [DllImport("mmgic3az.dll")]
        public static extern ulong mazShiftInt64R(ref ulong a, int shift);
        [DllImport("mmgic3az.dll")]
        public static extern ushort mazShiftInt16L(ushort a, int shift);
        [DllImport("mmgic3az.dll")]
        public static extern ushort mazShiftInt16R(ushort a, int shift);
        [DllImport("mmgic3az.dll")]
        public static extern void mazSetSeed(uint x);

        // メモリー
        [DllImport("mmgic3az.dll")]
        public static extern int mazBitArray(int command, int x, int y, ref int page);
        [DllImport("mmgic3az.dll")]
        public static extern int mazBitArray(int command, int x, int y, IntPtr page);

        [DllImport("mmgic3az.dll")]
        public static extern int mazQueue(int function, ref QUE_QUEUE queue, IntPtr value);
        [DllImport("mmgic3az.dll")]
        public static extern int mazQueue(int function, ref QUE_QUEUE queue, ref short value);            
        [DllImport("mmgic3az.dll")]
        public static extern int mazQueue(int function, ref QUE_QUEUE queue, ref int value);
        [DllImport("mmgic3az.dll")]
        public static extern int mazQueue(int function, ref QUE_QUEUE queue, ref long value);
        [DllImport("mmgic3az.dll")]
        public static extern int mazQueue(int function, ref QUE_QUEUE queue, ref Single value);
        [DllImport("mmgic3az.dll")]
        public static extern int mazQueue(int function, ref QUE_QUEUE queue, ref Double value);
        [DllImport("mmgic3az.dll")]
        public static extern int mazQueue(  int function,
                                        ref QUE_QUEUE queue,
                                        ref QUE_CONTAINER_A value );
        [DllImport("mmgic3az.dll")]
        public static extern int mazQueue(  int function, 
                                        ref QUE_QUEUE queue,
                                        ref QUE_CONTAINER_A_STRING value );
        [DllImport("mmgic3az.dll")]
        public static extern int mazQueue(  int function,
                                        ref QUE_QUEUE queue,
                                        ref QUE_CONTAINER_B_STRING value );
        [DllImport("mmgic3az.dll")]
        public static extern int mazQueue(  int function,
                                        ref QUE_QUEUE queue,
                                        ref QUE_CREATE value );
       
        [DllImport("mmgic3az.dll")]
        public static extern int mazStack(int function, ref STK1_STACK stack, IntPtr value);
        [DllImport("mmgic3az.dll")]
        public static extern int mazStack(int function, ref STK1_STACK stack, ref short value);
        [DllImport("mmgic3az.dll")]
        public static extern int mazStack(int function, ref STK1_STACK stack, ref int value);
        [DllImport("mmgic3az.dll")]
        public static extern int mazStack(int function, ref STK1_STACK stack, ref long value);
        [DllImport("mmgic3az.dll")]
        public static extern int mazStack(int function, ref STK1_STACK stack, ref Single value);
        [DllImport("mmgic3az.dll")]
        public static extern int mazStack(int function, ref STK1_STACK stack, ref Double value);
        [DllImport("mmgic3az.dll")]
        public static extern int mazStack(  int function,
                                        ref STK1_STACK stack,
                                        ref STK1_CONTAINER_A value );
        [DllImport("mmgic3az.dll")]
        public static extern int mazStack(  int function, 
                                        ref STK1_STACK stack,
                                        ref STK1_CONTAINER_A_STRING value );
        [DllImport("mmgic3az.dll")]
        public static extern int mazStack(  int function,
                                        ref STK1_STACK stack,
                                        ref STK1_CONTAINER_B_STRING value );
        [DllImport("mmgic3az.dll")]
        public static extern int mazStack(  int function, 
                                        ref STK1_STACK stack,
                                        ref STK1_CREATE value );

        [DllImport("mmgic3az.dll")]
        public static extern int mazStack(int function, ref STK2_STACK stack, IntPtr value);
        [DllImport("mmgic3az.dll")]
        public static extern int mazStack(int function, ref STK2_STACK stack, ref short value);
        [DllImport("mmgic3az.dll")]
        public static extern int mazStack(int function, ref STK2_STACK stack, ref int value);
        [DllImport("mmgic3az.dll")]
        public static extern int mazStack(int function, ref STK2_STACK stack, ref long value);
        [DllImport("mmgic3az.dll")]
        public static extern int mazStack(int function, ref STK2_STACK stack, ref Single value);
        [DllImport("mmgic3az.dll")]
        public static extern int mazStack(int function, ref STK2_STACK stack, ref Double value);
        [DllImport("mmgic3az.dll")]
        public static extern int mazStack(int function, ref STK2_STACK stack, ref STK2_CONTAINER value);
        [DllImport("mmgic3az.dll")]
        public static extern int mazStack(  int function,
                                        ref STK2_STACK stack,
                                        ref STK2_CONTAINER_STRING value );
        [DllImport("mmgic3az.dll")]
        public static extern int mazStack(int function, ref STK2_STACK stack, ref STK2_CREATE value);
       
        [DllImport("mmgic3az.dll")]
        public static extern IntPtr mazCopyMemory(int[] destination, int[] source, int size);
        [DllImport("mmgic3az.dll")]
        public static extern IntPtr mazCopyMemory(long[] destination, long[] source, int size);
        [DllImport("mmgic3az.dll")]
        public static extern IntPtr mazCopyMemory(short[] destination, short[] source, int size);
        [DllImport("mmgic3az.dll")]
        public static extern IntPtr mazCopyMemory(StringBuilder destination, IntPtr source, int size);
              
        [DllImport("mmgic3az.dll")]
        public static extern IntPtr mazFillMemory(int[] destination, byte fill, int size);
        [DllImport("mmgic3az.dll")]
        public static extern IntPtr mazFillMemory(long[] destination, byte fill, int size);
        [DllImport("mmgic3az.dll")]
        public static extern IntPtr mazFillMemory(short[] destination, byte fill, int size);

        [DllImport("mmgic3az.dll")]
        public static extern int mazGlobalCopy(StringBuilder  destination, IntPtr source, int size);
        [DllImport("mmgic3az.dll")]
        public static extern int mazGlobalCopy(StringBuilder destination, byte [] source, int size);
       

        // その他
        [DllImport("mmgic3az.dll")]
        public static extern int mazCaptureButton(IntPtr wnd);
        [DllImport("mmgic3az.dll")]
        public static extern int mazGetWorkArea(ref RECT workArea, int reserved);
        [DllImport("mmgic3az.dll")]
        public static extern void mazGetClient(IntPtr wnd, ref RECT client);
        [DllImport("mmgic3az.dll")]
        public static extern void mazGetTime(ref SYSTEMTIME systemTime, int time);
    }
}
